/* 4/25/1996 - Eduard Schwan (71513.2161@compuserve.com) - Added #ifndef around header for PCH */
#ifndef TE32K_H
#define TE32K_H

#include <Quickdraw.h>


typedef	struct {
	long	top,left,bottom,right;
} LongRect;

typedef	struct {
	long	h, v;
} LongPoint;


enum {
	te32KFOutlineHilite = 0,
	te32KFShowCarridgeReturns = 1,
	
	TE32KBitClear = 0,
	TE32KBitSet = 1,
	TE32KBitTest = -1
};

typedef Boolean (*TE32KProcPtr)(void);

extern Handle			TE32KScrpHandle;
#define kTE32KLimit		LONG_MAX

typedef	struct {
	LongRect			destRect;
	LongRect			viewRect;
	short				lineHeight;
	short				fontAscent;
	LongPoint			selPoint;
	long				selStart;
	long				selEnd;
	short				active;
	TE32KProcPtr			clikLoop;
	long				clickTime;
	Boolean				dblClick;
	long				clickLoc;
	short				clikStuff;
	long				caretTime;
	short				caretState;
	long				teLength;
	Handle				hText;
	short				txFont;
	char				txFace;
	short				txMode;
	short				txSize;
	short				tabWidth;
	short				tabChars;
	short				maxLineWidth;
	short				crOnly;
	GrafPtr				inPort;
	short				featureFlags;
	long				nLines;
	short				theCharWidths[256];
	long				lineStarts[1];
	
} 	TE32KRec, *TE32KPtr, **TE32KHandle;


	
extern	void			SetLongRect(LongRect *,long,long,long,long);
extern	void			LongRectToRect(LongRect *,Rect *);
extern	void			RectToLongRect(Rect *,LongRect *);
extern	void    		OffsetLongRect(LongRect *, long, long);

extern	void			TE32KInit(void);
extern	TE32KHandle		TE32KNew(LongRect *,LongRect *);
extern	void			TE32KDispose(TE32KHandle);
extern	void 			TE32KCalText(TE32KHandle);
extern	void			TE32KSetText(Ptr,long,TE32KHandle);
extern 	void			TE32KUseTextHandle(Handle, long, TE32KHandle);
extern	Handle			TE32KGetText(TE32KHandle);
extern	void			TE32KUpdate(LongRect *,TE32KHandle);
extern	void			TE32KScroll(long,long,TE32KHandle);
extern	void			TE32KActivate(TE32KHandle);
extern	void			TE32KDeactivate(TE32KHandle);
extern	void			TE32KIdle(TE32KHandle);
extern	void			TE32KKey(unsigned char,TE32KHandle);
extern	void			TE32KClick(Point,unsigned char,TE32KHandle);
extern	void			TE32KSetSelect(long,long,TE32KHandle);
extern	OSErr			TE32KToScrap(void);
extern	OSErr			TE32KFromScrap(void);
extern	void			TE32KCopy(TE32KHandle);
extern	void			TE32KCut(TE32KHandle);
extern	void			TE32KDelete(TE32KHandle);
extern	void			TE32KInsert(Ptr,long,TE32KHandle);
extern	void			TE32KPaste(TE32KHandle);
extern	Handle			TE32KScrapHandle(void);
extern	long			TE32KGetScrapLen(void);
extern	void			TE32KSetScrapLen(long);
extern	void			TE32KGetPoint(long,LongPoint *,TE32KHandle);
extern	long			TE32KGetOffset(LongPoint *,TE32KHandle);
extern	void			TE32KSelView(TE32KHandle);
extern	void			TE32KSetFontStuff(short, short, short, short, TE32KHandle);
extern	void			TE32KAutoView(char, TE32KHandle);
extern	short			TE32KFeatureFlag(short feature, short action, TE32KHandle theTE32KHandle);
extern	void			TE32KSetClickLoop(TE32KProcPtr clickProc, TE32KHandle theTE32KHandle);
extern	void			TE32KGetHiliteRgn(RgnHandle selectedRgn, TE32KHandle theTE32KHandle);
extern	void			TE32KCopyToScrap(TE32KHandle theTE32KHandle);
extern 	void			TE32KCutToScrap(TE32KHandle theTE32KHandle);
extern	void			TE32KPasteFromScrap(TE32KHandle theTE32KHandle);

#endif /* TE32K_H */
